package dev.peerat.parser;

public class SyntaxMissMatchException extends Exception{
	
	private static final long serialVersionUID = -635419322226790786L;
	
	private TokenValidator validator;
	
	public SyntaxMissMatchException(TokenValidator validator){
		this.validator = validator;
	}

	@Override
	public String getMessage(){
		return "Only "+validator.getValidatedTokenCount()+" out "+validator.getTokenCount()+" of tokens parsed !";
	}
	
	public String locateEndOfParsing(){
		int last = validator.getValidatedTokenCount();
		return "Last Token Validated: "+validator.getToken(last).toString()+" near to "+getTokenValue(last-2)+" "+getTokenValue(last-1)+" "+getTokenValue(last)+" "+getTokenValue(last+1)+" "+getTokenValue(last+2);
	}
	
	private String getTokenValue(int index){
		if(index < 0 || index >= validator.getTokenCount()) return "";
		return validator.getToken(index).getValue();
	}
}
