package dev.peerat.parser;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.function.Consumer;

public class TokenUpdater{
	
	private Map<Token, Consumer<Token>> map;
	private Token[] tokens;
	
	//tmp
	public TokenUpdater(){
		this.map = new HashMap<>();
	}
	
	public TokenUpdater(Token[] tokens){
		this.map = new HashMap<>();
		this.tokens = tokens;
	}
	
	public void setValue(Token token, String value){
		Consumer<Token> consumer = (current) -> current.setValue(value);
		Consumer<Token> current = this.map.get(token);
		map.put(token, current == null ? consumer : current.andThen(consumer));
	}
	
	public void setType(Token token, TokenType value){
		Consumer<Token> consumer = (current) -> current.setType(value);
		Consumer<Token> current = this.map.get(token);
		map.put(token, current == null ? consumer : current.andThen(consumer));
	}
	
	public void setLine(Token token, int value){
		Consumer<Token> consumer = (current) -> current.setLine(value);
		Consumer<Token> current = this.map.get(token);
		map.put(token, current == null ? consumer : current.andThen(consumer));
	}
	
	public void setCharacter(Token token, int value){
		Consumer<Token> consumer = (current) -> current.setCharacter(value);
		Consumer<Token> current = this.map.get(token);
		map.put(token, current == null ? consumer : current.andThen(consumer));
	}
	
	public void pushUpdates(){
		
		//tmp
		if(this.tokens == null){
			for(Entry<Token, Consumer<Token>> entry : this.map.entrySet()) entry.getValue().accept(entry.getKey());
			return;
		}
		
		for(int index = 0; index < this.tokens.length; index++){
			Token token = this.tokens[index];
			Consumer<Token> consumer = this.map.remove(token);
			if(consumer != null){
				int line = token.getLineNumber();
				int character = token.getCharacterNumber();
				String value = token.getValue();
				consumer.accept(token);
				
				if(token.getLineNumber() != line){
					int dif = token.getLineNumber()-line;
					for(int next = index+1; next < this.tokens.length; next++){
						Token update = this.tokens[next];
						if(update.getLineNumber() < line) break;
						update.setLine(update.getLineNumber()+dif);
					}
				}
				if(token.getCharacterNumber() != character || value.length() != token.getValue().length()){
					int dif = ((token.getCharacterNumber()+token.getValue().length())-(character+value.length()));
					for(int next = index+1; next < this.tokens.length; next++){
						Token update = this.tokens[next];
						if(update.getLineNumber() > line) break;
						update.setCharacter(update.getCharacterNumber()+dif);
					}
				}
			}
		}
		//warn -> if map not empty -> tried to update non-tracked token, like group on concat,...
	}
}
