package dev.peerat.parser.java.tree;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.Import;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.JavaFile;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class ImportTree extends SyntaxTree<JavaElement> {

	public ImportTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		this.current.then((validator) -> {
			if(validator.validate(
					(token) -> token.getValue().equals("import"))){
				
				validator.validate(
						(token) -> token.getValue().equals("static"),
						(bag, token) -> bag.set("static", null));
				
				while(validator.validate(
						(token) -> !token.getValue().equals(";"),
						(bag, token) -> {
							Token current = bag.get();
							if(current == null) bag.set(token);
							else bag.set(current.concat(token));
						})
					);
				
				return validator.validate((token) -> token.getValue().equals(";"));
			}
			return false;
		}).<JavaElement>end((parent, bag) -> {
			((JavaFile)parent).addImport(new Import(bag.has("static"), bag.get()));
			return parent;
		});
	}
}
