package dev.peerat.parser.java.tree;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.JavaFile;
import dev.peerat.parser.state.InitialStateTree;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class JavaTree extends SyntaxTree<JavaElement> {

	public JavaTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new InitialStateTree<>();
	}

	@Override
	public void init() {
		InitialStateTree<JavaElement> main = (InitialStateTree<JavaElement>) this.current;
		StateTree<JavaElement> pack = main.then((validator) -> {
			if(validator.validate(
					(token) -> token.getValue().equals("package"))){
				
				while(validator.validate(
						(token) -> !token.getValue().equals(";"),
						(bag, token) -> {
							Token current = bag.get();
							if(current == null) bag.set(token);
							else bag.set(current.concat(token));
						})
					);
				return validator.validate((token) -> token.getValue().equals(";"));
			}
			return false;
		}).end((parent, bag) -> {
			((JavaFile)parent).setPackage(bag.get());
			return parent;
		});
		
//		base.multiple(pack);
		main.multiple(registery.getNode(ImportTree.class));
		main.multiple(registery.getNode(AnnotationTree.class));
		main.multiple(registery.getNode(ClassBaseTree.class));
	}

}
