package dev.peerat.parser.java.visitor;

import java.util.function.Predicate;

import dev.peerat.parser.java.Function;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaFunctionVisitor extends JavaModifiableVisitor<Function, JavaFunctionVisitor>{
	
	//TODO MOD + annotation
	
	private Predicate<String> namePredicate;
	
	public JavaFunctionVisitor(boolean propagate){
		super(Function.class, propagate);
	}
	
	public JavaFunctionVisitor named(Predicate<String> predicate){
		this.namePredicate = predicate; //TODO CONCAT
		return this;
	}
	
	@Override
	public VisitorBag visitElement(Function element){
		VisitorBag bag = new VisitorBag();
		
		if(this.namePredicate != null){
			if(element.getName() == null) return bag;
			if(!this.namePredicate.test(element.getName().getValue())) return bag;
		}
		
		bag.compute(element);
		return bag;
	}
	
}
