package dev.peerat.parser.visitor;

import static dev.peerat.parser.java.visitor.JavaVisitor.allClass;
import static dev.peerat.parser.java.visitor.JavaVisitor.allJavaElement;
import static dev.peerat.parser.visitor.Operator.collect;
import static dev.peerat.parser.visitor.Visitor.token;

import dev.peerat.parser.java.JavaFile;
import dev.peerat.parser.java.JavaParser;
import dev.peerat.parser.java.JavaProject;

public class Example {
	
	public static void main(String[] args) throws Exception{
		
		JavaParser parser = new JavaParser();
		JavaFile container = new JavaFile();
		parser.parse("package dev.peerat.test; import a; import b; public class C{ public class D{ public void test(){} } } public class E{}",
				container);
		
		JavaProject project = new JavaProject();
		project.addFile(container);
		
		project.visit(
				collect(allClass())
				).<dev.peerat.parser.java.Class>toList().stream().map((c) -> c.getName().getValue()).forEach(System.out::println);
		
		
		System.out.println(container.visit(collect(allJavaElement().token(token().validate((token) -> token.getValue().equals("test"))))).toList());
		
//		Map<Class, List<Import>> map = project.visit(
//				and(
//					allFile().imp(value(allImport()))
//					,
//					allFile().clazz(key(allClass()))
//				)).toMapValues();
//		System.out.println(map);
	}

}
